#!/usr/bin/python
#
# mcast_send.py - simple multicast send utility for testing
#
# Usage:
#   mcast_send.py [multicast_group] [TTL]
#    Default multicast_group: 224.7.7.7
#    Default TTL: 1
#
# Ctrl+C to exit
#
# Based on /usr/share/doc/python2.5/examples/Demo/sockets/mcast.py from
# python2.5-examples debian package (apt-get install python2.5-examples)

PORT = 12345

import sys, os, time, socket, struct

mc_group = '224.7.7.7'
if len(sys.argv) > 1: mc_group = sys.argv[1]
mc_ttl = 1
if len(sys.argv) > 2: mc_ttl = int(sys.argv[2])

sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
sock.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL,
    struct.pack('b', mc_ttl))

c = 1
while True:
    d = 'mcast_send(%s): %d' % (mc_group, c)
    sock.sendto(d, (mc_group, PORT))
    print d
    c += 1
    time.sleep(1)
